import { CustomPlugin } from "distube";
import type { GuildMember, StageChannel, TextChannel, VoiceChannel } from "discord.js";
import type { SearchResult } from "distube";
declare type SpotifyPluginOptions = {
    api?: {
        clientId: string;
        clientSecret: string;
    };
    parallel?: boolean;
    emitEventsAfterFetching?: boolean;
};
export declare class SpotifyPlugin extends CustomPlugin {
    parallel: boolean;
    emitEventsAfterFetching: boolean;
    constructor(options?: SpotifyPluginOptions);
    validate(url: string): Promise<boolean>;
    play(voiceChannel: VoiceChannel | StageChannel, url: string, member: GuildMember, textChannel: TextChannel | undefined, skip: boolean, unshift: boolean): Promise<void>;
    search(query: string): Promise<SearchResult | null>;
}
export default SpotifyPlugin;
//# sourceMappingURL=index.d.ts.map