"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CustomPlugin = void 0;
const Plugin_1 = __importDefault(require("./Plugin"));
/**
 * Custom Plugin
 * @extends Plugin
 * @abstract
 */
class CustomPlugin extends Plugin_1.default {
    constructor() {
        super(...arguments);
        this.type = "custom";
    }
}
exports.CustomPlugin = CustomPlugin;
/**
 * This method will be executed if the url is validated.
 * @param {Discord.VoiceChannel|Discord.StageChannel} voiceChannel The voice channel will be joined
 * @param {string} url Validated url
 * @param {Discord.GuildMember} member Requested user
 * @param {Discord.TextChannel?} textChannel Default {@link Queue#textChannel}
 * @param {boolean} skip Skip the playing song (if exists) and play the added song/playlist instantly
 * @param {boolean} unshift Add the song/playlist to the beginning of the queue (after the playing song if exists)
 * @returns {Promise<void>}
 * @method play
 * @memberof CustomPlugin#
 * @abstract
 */
exports.default = CustomPlugin;
//# sourceMappingURL=CustomPlugin.js.map